package decorator_pattern.app;

import decorator_pattern.tech.MyFileInputStreamBuffer;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.nio.file.Files;
import java.time.Instant;

/**
 * @author weizhenfeng韦振凤
 * @version 1.0
 * @description: TODO
 * @date 2025/6/2 下午9:51
 */
public class App {

    public static void main(String[] args) {
        unOpt();

        opt();

    }

    private static void opt() {
        File file = new File("F:\\BigData\\交易模型\\交易模型-存款交易信息.xlsx");
        long startTime = Instant.now().toEpochMilli();

        try (
                InputStream fis = Files.newInputStream(file.toPath());
                InputStream bufferedStream = new MyFileInputStreamBuffer(fis) // 使用缓冲装饰器
        ) {
            while (bufferedStream.read() != -1) {
                // 空循环
            }
            System.out.println("缓冲读取耗时(ms): " + (Instant.now().toEpochMilli() - startTime));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void unOpt() {
        File file = new File("F:\\BigData\\交易模型\\交易模型-存款交易信息.xlsx");
        long epochMilli = Instant.now().toEpochMilli();
        try (FileInputStream fileInputStream = new FileInputStream(file)) {
            while (fileInputStream.read() != -1) {
                if (fileInputStream.read() == -1) {
                    break;
                }
            }
            System.out.println(Instant.now().toEpochMilli() - epochMilli);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
